module Pod
    class Installer
        attr_accessor :dry_deps
        alias install_t! install!
        def install!()
            if @dry_deps
                prepare
                resolve_dependencies
                exit 0
            else
                install_t!
            end
        end

    end

    class Command

        # This is an example of a cocoapods plugin adding a top-level subcommand
        # to the 'pod' command.
        #
        # You can also create subcommands of existing or new commands. Say you
        # wanted to add a subcommand to `list` to show newly deprecated pods,
        # (e.g. `pod list deprecated`), there are a few things that would need
        # to change.
        #
        # - move this file to `lib/pod/command/list/deprecated.rb` and update
        #   the class to exist in the the Pod::Command::List namespace
        # - change this class to extend from `List` instead of `Command`. This
        #   tells the plugin system that it is a subcommand of `list`.
        # - edit `lib/cocoapods_plugins.rb` to require this file
        #
        # @todo Create a PR to add your plugin to CocoaPods/cocoapods.org
        #       in the `plugins.json` file, once your plugin is released.
        #
        module ClassMethods
            def options
                options = [
                  ['--dry-deps','only test depend'],
                ]
                options.concat(super)
            end
        end
        class Install

            def self.options
                [
                  ['--repo-update', 'Force running `pod repo update` before install'],
                  ['--deployment', 'Disallow any changes to the Podfile or the Podfile.lock during installation'],
                  ['--clean-install', 'Ignore the contents of the project cache and force a full pod installation. This only applies to projects that have enabled incremental installation.'],
                  ['--dry-deps','only test depend'],
                ].concat(super).reject { |(name, _)| name == '--no-repo-update' }
            end

            # class << self
            #     options_t = instance_method(:options)
            #     # alias options_t options
            #     define_method(:options) do
            #     item = options_t.bind(self).call()
            #
            #         [
            #           ['--dry-deps','only test depend'],
            #         ].concat(item)
            #     end
            # end
            # class << self
            #     alias options_t options
            #     def options
            #         o = options_t
            #         o.push(['--dry-deps','only test depend'])
            #         o.concat(super)
            #     end
            #
            # end

            def initialize(argv)
                super
                @deployment = argv.flag?('deployment', false)
                @clean_install = argv.flag?('clean-install', false)
                @dry_deps = argv.flag?('dry-deps',false)
            end

            alias installer_for_config_t installer_for_config
            def installer_for_config
                item = installer_for_config_t
                if @dry_deps
                    item.dry_deps = @dry_deps
                end
                item
            end


        end
    end
end
