module Pod
    module Downloader
        autoload :LocalPath,'cocoapods-packager-ext/ext/downloader/lnpath'
        class << self
            alias downloader_class_by_key_t downloader_class_by_key
            def downloader_class_by_key
                keys = downloader_class_by_key_t
                keys[:lnpath] = LocalPath
                return keys
            end
        end
        class RemoteFile
            executable :ln

            alias filename_with_type_t filename_with_type
            def filename_with_type(type = :zip)
                if not type
                    "file"
                else
                    filename_with_type_t type
                end
            end
            alias extract_with_type_t extract_with_type
            def extract_with_type(full_filename, type = :zip)
                if not type
                    unpack_from = url
                    unpack_to = @target_path
                    FileUtils.rm_rf(unpack_to) if File.exist?(unpack_to)
                    FileUtils.rm_rf(unpack_to) if Dir.exist?(unpack_to)
                    ln! '-s',unpack_from,unpack_to
                else
                    extract_with_type_t full_filename,type
                end

            end
        end
    end
end